package net.xuyezo.main;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;

import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;

import io.papermc.paper.event.player.AsyncChatEvent;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.TextComponent;
import net.kyori.adventure.text.event.ClickEvent;

public class Handler implements Listener {
	Connection cc;
	
	public Handler(Connection c) {
		this.cc = c;
    	PreparedStatement stmt;
		try {
			stmt = cc.prepareStatement("CREATE TABLE IF NOT EXISTS main.text (username TEXT, date REAL, content TEXT)");
	    	stmt.executeUpdate();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
    @EventHandler
    public void onChat(AsyncChatEvent event) {
    	PreparedStatement stmt;
		try {
			stmt = cc.prepareStatement("INSERT INTO main.text (username, date, content) values (?, ?, ?)");
			stmt.setString(1, event.getPlayer().getName());
		    stmt.setLong(2,  System.currentTimeMillis());
		    stmt.setString(3, ((TextComponent) event.message()).content());
	    	stmt.executeUpdate();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    }
	
    @EventHandler
    public void onPlayerJoin(PlayerJoinEvent event) {
    	Player p = event.getPlayer();
    	p.sendMessage(Component.text("Confused on what this is?\nCheck out our Civilization community by clicking on this text.")
    				.clickEvent(ClickEvent.clickEvent(ClickEvent.Action.OPEN_URL,"https://mc.dervland.net/index.php")));
    	PreparedStatement stmt;
		try {
			stmt = cc.prepareStatement("INSERT INTO main.text (username, date, content) values (?, ?, ?)");
			stmt.setString(1, ":system");
		    stmt.setLong(2,  System.currentTimeMillis());
		    stmt.setString(3, p.getName().concat(" joined the server"));
	    	stmt.executeUpdate();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    }
    //TODO: rewrite this Junk
    @EventHandler
    public void onPlayerLeave(PlayerQuitEvent event) {
    	PreparedStatement stmt;
		try {
			stmt = cc.prepareStatement("INSERT INTO main.text (username, date, content) values (?, ?, ?)");
			stmt.setString(1, ":system");
		    stmt.setLong(2,  System.currentTimeMillis());
		    stmt.setString(3, event.getPlayer().getName().concat(" left the server"));
	    	stmt.executeUpdate();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    }
}
